package edu.cmu.sei.pacc.absdom;

import edu.toronto.cs.expr.NamedOp;
import edu.toronto.cs.expr.RationalOp;
import edu.toronto.cs.expr.Expr;


public class VariantOp extends NamedOp
{

  public static VariantOp NEXT = new VariantOp (1);
  public static VariantOp AUX = new VariantOp (2);
  
  int variantNum;
  
  private  VariantOp (int variantNum)
  {
    super ("VARIANT", 1);
    this.variantNum = variantNum;
  }
  
  public int getVariantNum ()
  {
    return variantNum;
  }
  

  public static Expr variantExpr (Expr name, int variant)
  {
    VariantOp op;
    
    switch (variant)
      {
      case 1: op = NEXT;
	break;
      case 2: op = AUX;
	break;
      default:
	op = new VariantOp (variant);
      }

    return name.getFactory ().op (op).unaryApply (name);
  }



  public static Expr next (Expr name)
  {
    return name.getFactory ().op (NEXT).unaryApply (name);
  }
  
  public static Expr aux (Expr name)
  {
    return name.getFactory ().op (AUX).unaryApply (name);
  }
  

  public static boolean isVariantExpr (Expr e)
  {
    return e.op ().getClass () == VariantOp.class;
  }
  
  public static Expr mainVariant (Expr e)
  {
    return e.arg (0);
  }
  
  public static int variantNum (Expr e)
  {
    return ((VariantOp)e.op ()).getVariantNum ();
  }
}
