package edu.toronto.cs.expr;

public abstract class AbstractOperator implements Operator
{
  int arity;
  String name;


  public AbstractOperator (String _name)
  {
    this (_name, -1);
  }
  
  public AbstractOperator (String _name, int _arity)
  {
    name = _name;
    arity = _arity;
  }
  
  
  public boolean isWellFormed (Expr[] args)
  {
    return arity == -1 || (args != null && args.length == arity);
  }

  public int arity ()
  {
    return arity;
  }
  
  public String name ()
  {
    return name;
  }

  public String toString ()
  {
    return name ();
  }
  
  public boolean equals (Object o)
  {
    return o != null && (o instanceof AbstractOperator) && 
      ((AbstractOperator)o).arity == arity && 
      ((AbstractOperator)o).name.equals (name);
  }
}
