package edu.toronto.cs.expr;

/**
 * Represents a C expression.
 *
 * Expressions without attributes and named children are defined here.
 */
public class CExprOp extends NamedOp
{
  public static final CExprOp ADDR_OF = new CExprOp ("addrOf", 1); 
  public static final CExprOp ARRAY_REF = new CExprOp ("arrayRef", -1); 
  public static final CExprOp COMPONENT_REF = new CExprOp ("compRef", -1); 
  public static final CExprOp REF = new CExprOp ("ref", -1); 

  public static final CExprOp ORDERED = new CExprOp ("ord", -1); 
  public static final CExprOp UNORDERED = new CExprOp ("unord", -1); 

  public static final CExprOp CEIL_DIV = new CExprOp ("cldiv", 2);
  public static final CExprOp FLOOR_DIV = new CExprOp ("fldiv", 2);
  public static final CExprOp ROUND_DIV = new CExprOp ("rddiv", 2);
  public static final CExprOp EXACT_DIV = new CExprOp ("exdiv", 2);

  public static final CExprOp UNEQ = new CExprOp("uneq", 2);
  public static final CExprOp UNLT = new CExprOp("ult", 2);
  public static final CExprOp UNLEQ = new CExprOp("unle", 2);
  public static final CExprOp UNGT = new CExprOp("ungt", 2);
  public static final CExprOp UNGEQ = new CExprOp("unge", 2);

  public static final CExprOp LTGT = new CExprOp("ltgt", 2);

  public static final CExprOp PREDEC = new CExprOp("predec", 1);
  public static final CExprOp PREINCR = new CExprOp("preinc", 1);
  public static final CExprOp POSTDEC = new CExprOp("postdec", 1);
  public static final CExprOp POSTINC = new CExprOp("postinc", 1);

  public static final CExprOp MIN = new CExprOp("min", 1);
  public static final CExprOp MAX = new CExprOp("max", 1);

  public static final CExprOp VA_ARG = new CExprOp("vaarg", -1);

  public static final CExprOp ASM = new CExprOp("asm", -1);

  public CExprOp (String name, int arity)
  {
    super (name, arity);
  }
}
