package edu.toronto.cs.expr;

public class CILDeclarationPointerOp extends NullaryOperator
{
  int numPointers = 0;

  public CILDeclarationPointerOp (int _numPointers)
  {
    numPointers = _numPointers;
  }

  public static int getNumPtrs (Expr e)
  {
    assert isPtr (e);
    return ((CILDeclarationPointerOp) e.op ()).numPointers;
  }

  public static final boolean isPtr (Expr e)
  {
    return e.op () instanceof CILDeclarationPointerOp;
  }

  public String name ()
  {
    return numPointers == 1 ? "pointer" : "pointers (" + numPointers + ")";
  }
}
