package edu.toronto.cs.expr;

import edu.toronto.cs.util.Primes;

/**
 * Abstracts common features of var, parm, and result; a "loc" is an
 * identifier that can be read from or written to.
 */
public class CLocOp extends AbstractOperator
{
  String locName;
  Integer uid;

  public CLocOp (String opName, String locName, Integer uid)
  {
    super (opName, 0);
    this.locName = locName;
    this.uid = uid;
  }

  public static final boolean isCLoc (Expr e)
  {
    return e instanceof CLocOp;
  }

  public static final int uid (Expr e)
  {
    return ((CLocOp) e.op ()).uid;
  }

  public boolean equals (Object v)
  {
    if (this == v) return true;

    return
      v != null &&
      v instanceof CLocOp &&
      ((CLocOp) v).name ().equals (this.name ()) &&
      ((CLocOp) v).locName.equals (this.locName) &&
      ((CLocOp) v).uid.equals (this.uid);
  }
  
  public int hashCode ()
  {
    return locName.hashCode () + (int) ((Primes.getPrime (0) * uid) >>> 32); 
  }
}
