package edu.toronto.cs.expr;

import edu.toronto.cs.util.Primes;

/**
 * A C declaration with a name. A null name is allowed
 *
 */
public abstract class CNamedDeclOp extends CDeclOp
{

  String declName;

  public CNamedDeclOp (String opName, int arity, int uid, 
		       Expr context, String _declName)
  {
    super (opName, arity, uid, context);
    declName = _declName;
  }

  public static String declName (Expr e)
  {
    return ((CNamedDeclOp)e.op ()).declName;
  }
  

  public static boolean isCNamedDecl (Expr e)
  {
    return (e.op () instanceof CNamedDeclOp);
  }

}
