package edu.toronto.cs.expr;


public class NondetOp extends NullaryOperator
{

  public static final NondetOp NONDET = new NondetOp ();

  protected NondetOp ()
  {
    super ();
  }
  
  public String name ()
  {
    return "YASM_NONDET";
  }
  
  public static final boolean isNondet (Expr e)
  {
    return e.op () == NONDET;
  }

  public static final boolean hasNondet (Expr e)
  {
    if (isNondet (e)) return true;
    
    for (int i = 0; i < e.arity (); i++)
      if (isNondet (e.arg (i))) return true;
    return false;
  }
  
}
