package edu.toronto.cs.gui;

import salvo.jesus.graph.*;
import salvo.jesus.graph.visual.*;
import salvo.jesus.graph.visual.layout.*;
import salvo.jesus.graph.visual.drawing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import edu.toronto.cs.openjgraph.*;


/**
 * @author  Jesus M. Salvo Jr.
 */

public class OpenJGraphFrame extends JFrame 
{

  public VisualGraph vgraph;
  DirectedGraph dgraph;
  Vertex rootNode;

  public OpenJGraphFrame (DirectedGraph _dgraph, Vertex _rootNode)
  {
    dgraph = _dgraph;
    rootNode = _rootNode;
    
    addWindowListener (new WindowAdapter () 
    {
      public void windowClosing (WindowEvent wev) 
      {
	quit ();
      }
    });
  
  }
  
  
  public void quit ()
  {
    setVisible (false);
    dispose ();
  }
  

  public void showDirectedGraph() {
    GraphEditor         editor;
    GraphLayoutManager  layoutManager;
    
    // Get a VisualGraph
    editor = new GraphEditor();
    editor.setGraph( dgraph );
    vgraph = editor.getVisualGraph();
    
        // Initialise a Tree layout manager
    
    
    layoutManager = new LayeredGraphLayout (editor.getVisualGraph (), rootNode);
    editor.setGraphLayoutManager( layoutManager );
    
    
    // Make it all visible
    this.getContentPane().setLayout( new GridLayout(1,2));
    this.getContentPane().add( editor );
    
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = new Dimension( screenSize.width - 80, screenSize.height - 80 );
    
    this.setSize( frameSize );
    this.setLocation((int)(screenSize.getWidth() - frameSize.getWidth()) / 2, (int)(screenSize.getHeight() - frameSize.getHeight()) / 2);
    
   
  }
  

}
