package edu.toronto.cs.proof;

import edu.toronto.cs.mvset.*;
import edu.toronto.cs.modelchecker.*;
import edu.toronto.cs.ctl.*;
import edu.toronto.cs.algebra.*;
import java.util.*;

public class ConjProofStep extends ProofStep
{
  protected ConjProofStep(AlgebraValue _v, MvSet _state, String _stateName,
			  CTLNode _consequent)
  {
    super(_v, _state, _stateName, _consequent);
  }

  public boolean unfold ()
  {
    AlgebraValue vl;
    AlgebraValue vr;
    BitSet tbs;

    MvSetModelChecker mc = ProofStepFactory.getMC();

    // -- vector of assignments corresponding to state
    //AlgebraValue[] stateEnv; 

    int i = 0;

    //stateEnv = getStateAsArray ();
    makeSingleState ();
    //     = (AlgebraValue[]) 
    // 	state.getPreImageArray (v.getParentAlgebra().top()).iterator().next();


    // XXX this evaluates the left and right hand sides of /\ and 
    // XXX creates new proof steps based on that. The use of cofactor
    // XXX here and getImage are wrong!

    // XXX Probably should not use cofactor here, or at least not
    // XXX this version!
    //tbs = mc.checkCTL (consequent.getLeft()).cofactor(stateEnv).getImage();

    // -- find the first set bit in the image 
    // XXX can BitSet do that for us?!
    //while (!tbs.get (i)) i++;

    // -- convert this to an algebra value
    //vl = v.getParentAlgebra ().getValue (i);
    vl = mc.checkCTL (consequent.getLeft (), state).getValue ();

    
    // -- reset our counter
    //i = 0;
    
    // -- same thing for right hand of AND
    //tbs = mc.checkCTL(consequent.getRight()).cofactor(stateEnv).getImage();
    

    //while (!tbs.get(i)) i++;
    //vr = v.getParentAlgebra ().getValue (i);
    vr = mc.checkCTL (consequent.getRight (), state).getValue ();


    antecedents.add (ProofStepFactory.makeProofStep(vl,
						    state,
						    consequent.getLeft()));
    antecedents.add (ProofStepFactory.makeProofStep(vr,
						    state,
						    consequent.getRight()));
    unfolded = true;
    return true;
  }
  
  public Object accept (ProofVisitor pv, Object info)
  {
    return pv.visitAndStep (this,  info);
  }
  
}

