package edu.toronto.cs.tp;

import junit.framework.TestCase;

import edu.toronto.cs.expr.*;

public class CVCLExprPrinterTestCase extends TestCase
{
	private CVCLExprPrinter printer;
	private ExprFactory fac;
	
	/**
	 * Called before every test case method.
	 */
	protected void setUp ()
	{
		printer = new CVCLExprPrinter ();
		fac = new ExprFactoryImpl ();
	}

	/**
	 * Tests translation of less-than Op.
	 */
	public void testLT ()
	{
		Expr x = fac.var ("x");
		Expr y = fac.var ("y");
		Expr x_lt_y = fac.op (ComparisonOp.LT).binApply (x, y);

		assertEquals (printer.print (x_lt_y), "(x < y)");
	}
}
