package edu.toronto.cs.tp;

import edu.toronto.cs.expr.*;

import java.util.*;

/** 
 * A simple symbol table which maps Exprs to type Exprs.
 *
 * XXX probably doesn't belong in the tp package.
 *
 * @author Kelvin Ku (kelvin@cs.toronto.edu)
 * @version 
 */
public class SymbolTable
{
  
  /** 
   * A Map from variable Exprs to type Exprs. 
   */
  Map<Expr, Expr> symbolMap;

  public SymbolTable ()
  {
    symbolMap = new IdentityHashMap<Expr, Expr> ();
  }

  public Expr typeOf (Expr e)
  {
    //assert e.op () instanceof VariableOp : "can't get type of " + e;
    Expr type = symbolMap.get (e);
    return type;
  }

  public void put (Expr e, Expr type) throws SymbolTableException
  {
    //assert e.op () instanceof VariableOp;
    if (symbolMap.containsKey (e))
      throw new SymbolTableException ("Redeclaring symbol " + e);
    symbolMap.put (e, type);
  }

  /** 
   * Returns the variables (keys) in the symbol table.
   */
  public Set<Expr> varSet ()
  {
    return symbolMap.keySet ();
  }

  public String toString ()
  {
    return symbolMap.toString ();
  }

  public static class SymbolTableException extends RuntimeException
  {
    public SymbolTableException (String msg)
    {
      super (msg);
    }
  }
}

