package edu.toronto.cs.yasm.abstractor;

import edu.toronto.cs.expr.*;
import edu.toronto.cs.yasm.pprogram.*;
import edu.toronto.cs.cxmlparser.CXMLParser;
import java.io.*;

/**
 * Utility class for parsing an XML C file into a PProgram.
 */
public class CNullExprAbstractorUtil
{
  public static PProgram parse (File cFile, ExprFactory efac)
    throws ParseException
    {
      CXMLParser chandler = new CXMLParser (efac);
      try
	{
	  chandler.parse (cFile);
	}
      catch (Exception ex)
	{
	  throw new ParseException ("Error parsing", ex);
	}
      return CNullExprAbstractor.absProgram (efac, chandler.getCProgram ());
    }

  public static void main (String args[]) throws Exception
  {
    
    parse (new File (args [0]), new ExprFactoryImpl ()).print 
      (new PrintWriter (new OutputStreamWriter (System.out), true));
  }

  public static class ParseException extends Exception
  {
    public ParseException (String msg, Exception ex)
    {
      super (msg, ex);
    }
  }
}
