package edu.toronto.cs.yasm.abstractor;

import java.io.*;
import antlr.*;
import edu.toronto.cs.cparser.block.*;
import edu.toronto.cs.expr.*;
import edu.toronto.cs.tp.*;

public class DeclsParserUtil
{
  public static DeclsParser newBlockDeclsParser ()
  {
    DeclsParser declsParser = new DeclsParser ();
    declsParser.setASTNodeClass (Block.class.getName ());
    Block.setTokenVocabulary
      (edu.toronto.cs.cparser.CILTokenTypes.class.getName ());
    return declsParser;
  }

  public static Expr parseBlockTypeSpecifiers (Block b, ITheoremProver tp)
  throws RecognitionException
  {
    return newBlockDeclsParser ().declSpecifiers (b, tp);
  }

  public static Expr parseExprTypeSpecifiers (Expr e, ITheoremProver tp)
  {
    // XXX stub, need to look for actual types at some point
    return tp.exprFactory ().op (SimpleTypeOp.INT);
  }

  public static Expr parseBlockDecl (Block b, ITheoremProver tp)
  {
    try
    {
      return newBlockDeclsParser ().declaration (b, tp);
    }
    catch (RecognitionException ex)  
    {
      ex.printStackTrace ();
      return null;
    }
  }

  public static Expr parseExprDecl (Expr e, ITheoremProver tp)
  {
    Expr var = tp.exprFactory ().var (CILDeclarationOp.getDeclName (e));
    // XXX for now assume everything is an integer but need to do 
    // XXX a better job in the future
    tp.declare (var, tp.exprFactory ().op (SimpleTypeOp.INT));
    return var;
  }
}
