package edu.toronto.cs.yasm.eqsolver;

import java.util.Map;
import java.util.List;
import java.util.Collections;


/**
 * Describe class AbstractEquation here.
 *
 *
 * Created: Mon Jun  4 14:45:12 2007
 *
 * @author <a href="mailto:arie@pcawf.sei.cmu.edu">Arie Gurfinkel</a>
 * @version 1.0
 */
public abstract class AbstractEquation<V> implements Equation<V>
{
  int defVar;
  List<Integer> useVars;

  public AbstractEquation (int defVar, int useVar)
  {
    this.defVar = defVar;
    useVars = Collections.singletonList (useVar);
  }

  public AbstractEquation (int defVar, List<Integer> useVars)
  {
    this.defVar = defVar;
    this.useVars = useVars;
  }

  public int getDefVar ()
  {
    return defVar;
  }

  public List<Integer> getUseVars ()
  {
    return useVars;
  }
  
  public abstract V eval (Map<Integer,V> env);


  public boolean maybeUnstable (Map<Integer,V> env)
  {
    return true;
  }
  
  public boolean mayChange (Map<Integer,V> newEnv, int var, V oldV, V newV)
  {
    return maybeUnstable (newEnv);
  }
  
  public boolean isUpwardStable (Map<Integer,V> env)
  {
    return false;
  }
  
  public boolean isDownwardStable (Map<Integer,V> env)
  {
    return false;
  }
  
}
