package edu.toronto.cs.yasm.eqsolver;

/**
 * Describe interface VariableChangedEventListener here.
 *
 *
 * Created: Thu May 31 16:26:34 2007
 *
 * @author <a href="mailto:arie@pcawf.sei.cmu.edu">Arie Gurfinkel</a>
 * @version 1.0
 */
public interface VariableChangedEventListener<V> 
{
  /**
   * Fired when variable {@code var} in {@code solver} changed 
   * its value from {@code oldV} to {@code newV}.
   *
   * @param solver an Equation solver
   * @param var variable that changed a value
   * @param oldV the old value of {@code var}
   * @param newV the new value of {@code newV}
   */
  void valueChanged (EqSolver<V> solver, int var, V oldV, V newV);
}
