/**
   Yet Another Software Model Checker (YASM)
   <p>
   Main application lives in {@link edu.toronto.cs.yasm.YasmApp YasmApp}.

   <h2>Dataflow of {@link edu.toronto.cs.yasm.YasmApp YasmApp}</h2>
   <ol>
   <li>
   Command line options are parsed using 
   {@link edu.toronto.cs.util.Clapi Clapi}
   </li>
   <li> 
   A input C file is parsed and abstracted into 
   {@link edu.toronto.cs.yasm.pprogram.PProgram PProgram} (Predicate Program) 
   using {@link edu.toronto.cs.yasm.pprogram.PProgram#parse PProgram.parse}
   which does the following
     <ol>
       <li>
       Parses the C program into an 
       {@link edu.toronto.cs.expr.Expr expression} using 
           {@link edu.toronto.cs.cparser.CILTransformerUtil}
       </li>
       <li>Constructs an initial abstraction of the program using {@link edu.toronto.cs.yasm.abstractor.NullExprAbstractor NullExprAbstractor} 
       </li>
     </ol>
   
    <li>
    A CTL property is parsed into {@link edu.toronto.cs.ctl.CTLNode} using 
      {@link edu.toronto.cs.ctl.antlr.CTLNodeParser}
    </li>
    <li> Main abstraction/refinement loop begins
    <ol>
      
      <li>Compile {@code PProgram} into {@link
      edu.toronto.cs.modelchecker.XKripkeStructure XKripkeStructure}
      (a symbolic {@link edu.toronto.cs.mvset.MvSet MvSet}
      representation of the transition relation of the program) using
      an implementation of a {@link
      edu.toronto.cs.yasm.pprogram.PProgramCompiler PProgramCompiler}.
      </li>

      <li> Check the property using {@link
      edu.toronto.cs.modelchecker.MvSetModelChecker MvSetModelChecker}.
      </li>

      <li> Stop if the result is conclusive (either true or false),
      continue if the result is inconclusive (maybe) </li>

      <li> Construct a partial proof (counterexample) using {@link
      edu.toronto.cs.proof2.CTLProver} util a possible refinement
      location is found</li>

      <li> Use one of the implementations of {@link
      edu.toronto.cs.yasm.pgenerator.PredicateGenerator} to generate
      new predicates.</li>

      <li> Refine the current {@code PProgram} with the new predicates
      using an implementation of {@link
      edu.toronto.cs.yasm.abstractor.PredicateRefiner}</li>
    </ol>
    </li>
   </ol>

   Here is a pictorial overview of the dataflow</br>
   <img src="doc-files/arch.png"/>
  
   
   
*/
package edu.toronto.cs.yasm;
