package edu.toronto.cs.yasm.pcfa;

import edu.toronto.cs.util.Primes;
import edu.toronto.cs.mvset.MvSet;


/**
 * Describe class HyperEdge here.
 *
 *
 * Created: Wed Jun  8 13:38:04 2005
 *
 * @author <a href="mailto:arie@eon.cs">Arie Gurfinkel</a>
 * @version 1.0
 */
public abstract class HyperEdge extends Edge 
{

  Node.NodeId[] dsts;
  
  /**
   * Creates a new <code>HyperEdge</code> instance.
   *
   */
  public HyperEdge (Node.NodeId _src, Node.NodeId[] _dsts) 
  {
    super (_src, _dsts [0]);
    dsts = _dsts;
  }

  public Node.NodeId getDst ()
  {
    return dsts [0];
  }
  
  public Node.NodeId[] getAllDst ()
  {
    return dsts;
  }

  public boolean hasDst (Node.NodeId id)
  {
    for (int i = 0; i < dsts.length; i++)
      if (dsts [i].equals (id)) return true;
    return false;
  }
  
  public boolean equals (Object o)
  {
    if (o == null) return false;
    if (o == this) return true;
    if (! (o instanceof HyperEdge)) return false;
    if (! super.equals (o)) return false;
    Node.NodeId[] otherDsts = ((HyperEdge)o).getAllDst ();
    
    if (otherDsts.length != dsts.length) return false;
    
    for (int i = 0; i < dsts.length; i++)
      if (!(otherDsts [i].equals (dsts [i]))) return false;
    return true;
  }

  
  public int hashCode ()
  {
    long hash = ((long) src.intValue ()) * Primes.getPrime (0);
    
    for (int i = 0; i < dsts.length; i++)
      hash += dsts [i].intValue () * Primes.getPrime (i + 1);
    return (int) hash;
  }
  

}
