package edu.toronto.cs.yasm.pcfa;

import java.util.*;

import edu.toronto.cs.mvset.MvSet;


/**
 * Describe class NodeSet here.
 *
 *
 * Created: Wed Jun  8 14:34:41 2005
 *
 * @author <a href="mailto:arie@eon.cs">Arie Gurfinkel</a>
 * @version 1.0
 */
public class NodeSet 
{
  
  NodeSet next;
  NodeSet prev;
  
  int count;
  
  Map nodes;
  
  /**
   * Creates a new <code>NodeSet</code> instance.
   *
   */
  public NodeSet () 
  {
    this (new HashMap (), null, null, 0);
  }

  protected NodeSet (Map _nodes, NodeSet _prev, NodeSet _next, int _count)
  {
    nodes = _nodes;
    prev = _prev;
    next = _next;
    count = _count;
  }
  

  public Node get (Node.NodeId id)
  {
    return (Node) nodes.get (id);
  }
  
  public void add (Node v)
  {
    nodes.put (v.getId (), v);
  }
  public void add (Node.NodeId id, MvSet value)
  {
    // XXX may want to consider to check if the node is already there
    // XXX and reuse it
    add (new Node (id, value));
  }


  public Collection nodes ()
  {
    return nodes.values ();
  }
  
  
  public int size ()
  {
    return nodes.size ();
  }
  
  protected void setNext (NodeSet v)
  {
    next = v;
  }
  protected void setPrev (NodeSet v)
  {
    prev = v;
  }
  
  public NodeSet getNext ()
  {
    return next;
  }
  public NodeSet getPrev ()
  {
    return prev;
  }
  
  public NodeSet copy ()
  {
    return new NodeSet ((Map) ((HashMap)nodes).clone (),
			null, null, 0);
  }
  
  public NodeSet createNext ()
  {
    assert getNext () == null : "createNext called twice";
    
    NodeSet ns = new NodeSet ((Map) 
			      ((HashMap)nodes).clone (), 
			      this, null, count + 1);
    setNext (ns);
    return ns;
  }

  public int getCount ()
  {
    return count;
  }
  

  public String dump ()
  {
    StringBuffer sb = new StringBuffer ();

    sb.append ("NodeSet: count: " + count + " \n");
    for (Iterator it = nodes.values ().iterator (); it.hasNext (); )
      sb.append (it.next ().toString ());

    sb.append ("END OF NODESET\n");
    
    return sb.toString ();
  }
  
  

}
