package edu.toronto.cs.yasm.pgenerator;

import java.util.*;
import edu.toronto.cs.expr.Expr;


/**
 * A predicate generator that chains other predicate generators.
 *
 * @author Arie Gurfinkel
 * @version 1.0
 */
public class ChainPredicateGenerator implements PredicateGenerator
{
  // -- list of generators we know about
  List<PredicateGenerator> pGenerators;

  // -- predicate generator that actually found something
  PredicateGenerator worked;

  public ChainPredicateGenerator ()
  {
    pGenerators = new LinkedList<PredicateGenerator> ();
  }

  public ChainPredicateGenerator add (PredicateGenerator p)
  {
    pGenerators.add (p);
    return this;
  }

  public boolean find ()
  {
    for (PredicateGenerator pg : pGenerators)
      if (pg.find ()) 
	{
	  worked = pg;
	  return true;
	}
    
    worked = null;
    return false;
  }
  
    
  
  public List<Expr> getNewPreds ()
  {
    return worked != null ? worked.getNewPreds () : new LinkedList<Expr> ();
  }
  

}
