package edu.toronto.cs.yasm.pgenerator;

import edu.toronto.cs.expr.Expr;
import java.util.List;



/**
 * A generic predicate generator interface
 *
 * @author <a href="mailto:arie@marvin.aguga.net">Arie Gurfinkel</a>
 * @version 1.0
 */
public interface PredicateGenerator
{
  /**
   * Runs the predicate generator and returns true if 
   * anything has changed like new predicates are added 
   * or the abstraction of the program has changed
   *
   * @return a <code>boolean</code> value
   */
  boolean find ();

  /**
   * Returns a list of new predicates found
   *
   * @return a <code>List</code> value
   */
  List<Expr> getNewPreds ();
}
