package edu.toronto.cs.yasm.pprogram;

/**
 * Describe class BasePProgramVisitor here.
 *
 *
 * Created: Fri Jun 17 15:24:58 2005
 *
 * @author <a href="mailto:arie@eon.cs">Arie Gurfinkel</a>
 * @version 1.0
 */
public class BasePProgramVisitor implements PProgramVisitor
{
  public Object visitPProgram (PProgram p, Object o)
  {
    return o;
  }
  
  public Object visitBreak (BreakPStmt s, Object o)
  {
    return visitGoto (s, o);
  }

  public Object visitFunctionCall (FunctionCallPStmt s, Object o)
  {
    return visitPStmt (s, o);
  }
  
  public Object visitFunctionCallPrologue (FunctionCallPrologue s, Object o)
  {
    return visitPrllAsmt (s, o);
  }
  
  public Object visitFunctionCallEpilogue (FunctionCallEpilogue s, Object o)
  {
    return visitPrllAsmt (s, o);
  }
  
  public Object visitGoto (GotoPStmt s, Object o)
  {
    return visitPStmt (s, o);
  }
  
  public Object visitIf (IfPStmt s, Object o)
  {
    return visitPStmt (s, o);
  }
  
  public Object visitNDGoto (NDGotoPStmt s, Object o)
  {
    return visitPStmt (s, o);
  }
  
  public Object visitPrllAsmt (PrllAsmtPStmt s, Object o)
  {
    return visitPStmt (s, o);
  }
  
  public Object visitDecl (PDecl d, Object o)
  {
    return o;
  }
  
  public Object visitFunctionDef (PFunctionDef d, Object o)
  {
    return o;
  }
  
  public Object visitPStmt (PStmt s, Object o)
  {
    return o;
  }
  
  public Object visitReturn (ReturnPStmt r, Object o)
  {
    return visitPrllAsmt (r, o);
  }
  
  public Object visitReturnSelector (ReturnSelectorPStmt r, Object o)
  {
    return visitPStmt (r, o);
  }
  
  public Object visitSkip (SkipPStmt s, Object o)
  {
    return visitPStmt (s, o);
  }
  
  public Object visitWhile (WhilePStmt s, Object o)
  {
    return visitIf (s, o);
  }
  
}
