package edu.toronto.cs.yasm.pprogram;

import edu.toronto.cs.mvset.*;

import java.util.Arrays;


public class FunctionCallMvRelation implements MvRelation
{
  MvSet invariant;
  MvSet selector;
  MvSet selectorCube;
  MvRelation args;
  
  public FunctionCallMvRelation (MvSet _invariant, MvSet _selector,
                                 MvSet _selectorCube, MvRelation _args)
  {
    invariant = _invariant;
    selector = _selector;
    selectorCube = _selectorCube;
    args = _args;
  }

  public void setTrans (MvSet v)
  {
  }
  
  public MvSet fwdImage (MvSet v)
  {
    if (v == v.getFactory ().bot ())
      return v;
    
    return selector.and (args.fwdImage (v));
  }
  public MvSet dualBwdImage (MvSet v)
  {
    return bwdImage(v.not ()).not ();
  }

  public MvSet bwdImage (MvSet v)
  {
    if (v.equals (v.getFactory ().bot ()))
      return v;

    //return args.bwdImage (selector.and (v).existAbstract (selectorCube));
    return args.bwdImage (v.cofactor (selector));
    
  }
  public MvSet toMvSet ()
  {
    throw new RuntimeException ("not implemented");
  }



  /**
   * return cube of pre-state variables
   *
   */
  public MvSet getPreVariablesCube ()
  {
    throw new UnsupportedOperationException 
      (this.getClass () + 
       " does not support this method");

  }


  /**
   * get cube of post-state variables
   *
   */
  public MvSet getPostVariablesCube ()
  {
    throw new UnsupportedOperationException 
      (this.getClass () + 
       " does not support this method");

  }



  /**
   * get map from pre- to post-state variables
   *
   */
  public int[] getPreToPostMap ()
  {
    throw new UnsupportedOperationException 
      (this.getClass () + 
       " does not support this method");
      
  }



  /**
   * get map from post- to pre-state variables
   *
   */
  public int[] getPostToPreMap ()
  {
    throw new UnsupportedOperationException 
      (this.getClass () + 
       " does not support this method");
      
  }
    
  
  
}
