package edu.toronto.cs.yasm.pprogram;

import edu.toronto.cs.cparser.block.Block;
import java.io.*;
import edu.toronto.cs.yasm.abstractor.*;
import edu.toronto.cs.expr.*;
import antlr.RecognitionException;

import edu.toronto.cs.yasm.wp.*;

public class ReturnPStmt extends PrllAsmtPStmt
{
  public ReturnPStmt (PFunctionDef parent, Block sourceBlock)
  {
    super (parent, sourceBlock);
  }

  public ReturnPStmt (PFunctionDef parent, Expr sourceExpr)
  {
    super (parent, sourceExpr);
  }

  public Object accept (PProgramVisitor v, Object o)
  {
    return v.visitReturn (this, o);
  }


  public void printMe (PrintWriter out)
  {
    out.print (getId () + "/" + getLabel () + ": ");
    /*
       if (sourceBlock != null)
       out.println ("return (" + sourceBlock.getLineNum () + ")");
       else
       out.println ("return (no-line-number)");
       */

    /* do sourceExpr case */  
    out.println ("(" + parent.getFunctionName () + ") " + sourceExpr);
  }

  public WPComputer getWPComputer ()
  {
    ExprFactory fac = getParent ().getParent ().getExprFactory ();
    if (sourceExpr != null && wpComputer == null)
    {
      if (CILReturnOp.isCILReturn (sourceExpr))
      {
        if (CILReturnOp.hasReturnValue (sourceExpr))
        {
          Expr returnExpr;
          returnExpr = fac.op (CILAssignOp.ASSIGN).binApply (
              getParent ().getReturnValueVar (),
              CILReturnOp.getReturnValue (sourceExpr));
          wpComputer = new ExprWPComputer (returnExpr);
        }
        else
        {
          wpComputer = ExprWPComputer.ID;
        }
      }
      else if (CStmtOp.isReturn (sourceExpr))
      {
        if (sourceExpr.arity () > 0)
          wpComputer = new ExprWPComputer (
            CStmtOp.modifyExpr (
              getParent ().getReturnValueVar (),
              sourceExpr.arg (0)));
        else
          wpComputer = ExprWPComputer.ID;
      }
      else
        throw new RuntimeException ("Unknown sourceExpr " + sourceExpr.op ().getClass ());
    }
    return wpComputer;
  }
  public int getLineNum ()
  {
    Expr src = getSourceExpr ();
    if (src == null) return super.getLineNum ();
    if (src.arity () != 2)
    {
      System.err.println ("Strange assignment without a line number");
      System.err.println ("Srouce expr: " + src);
      return super.getLineNum ();
    }


    return RationalOp.getN (src.arg (1));
  }

}

