package edu.toronto.cs.yasm.pprogram;

import edu.toronto.cs.cparser.*;
import edu.toronto.cs.cparser.block.*;

import edu.toronto.cs.expr.Expr;

import java.io.PrintWriter;



/**
 * SkipPStmt.java
 *
 *
 * Created: Fri Jun 25 14:21:32 2004
 *
 * @author <a href="mailto:kelvin@tallinn.cs">Kelvin Ku</a>
 * @version 1.0
 */
public class SkipPStmt extends PStmt
{
  public SkipPStmt (PFunctionDef parent, Expr sourceExpr)
  {
    super (parent, sourceExpr);
  }

  public SkipPStmt (PFunctionDef parent)
  {
    super (parent, (Expr) null);
  }

  public Object accept (PProgramVisitor v, Object o)
  {
    return v.visitSkip (this, o);
  }
  

  public void printMe (PrintWriter out)
  {
    out.print (getId () + "/" + getLabel () + ": ");

    if (sourceBlock != null)
      out.println ("skip" + " (" + sourceBlock.getLineNum () + ")");
    else
      out.println ("skip (no-line-number)");

    // XXX add sourceExpr case  
  }
  
}
