package edu.toronto.cs.yasm.reachability;

import edu.toronto.cs.yasm.pcfa.*;
import edu.toronto.cs.algebra.*;

/**
 * Describe class EdgeProofGoal here.
 *
 *
 * Created: Mon Jun 13 11:12:01 2005
 *
 * @author <a href="mailto:arie@eon.cs">Arie Gurfinkel</a>
 * @version 1.0
 */
public class EdgeProofGoal extends ProofGoal 
{

  Node src;
  Node dst;
  
  Edge edge;
  AlgebraValue value;
  
  /**
   * Creates a new <code>EdgeProofGoal</code> instance.
   *
   */
  public EdgeProofGoal (ProofGoal _parent, Node _src, Node _dst, 
			Edge _edge, AlgebraValue _value) 
  {
    super (_parent);
    src = _src;
    dst = _dst;
    edge = _edge;
    value = _value;
  }

  public Node getSrc ()
  {
    return src;
  }
  
  public Node getDst ()
  {
    return dst;
  }
  
  public Edge getEdge ()
  {
    return edge;
  }
  
  public AlgebraValue getValue ()
  {
    return value;
  }

  public String toString ()
  {
    return getSrc ().getId () + " -(" + getValue () + ")-> " + 
      getDst ().getId ();
  }
  

}
