package edu.toronto.cs.yasm.reachability;


import edu.toronto.cs.algebra.*;

/**
 * Describe class ReachabilityProofRule here.
 *
 *
 * Created: Fri Jun 10 16:27:28 2005
 *
 * @author <a href="mailto:arie@eon.cs">Arie Gurfinkel</a>
 * @version 1.0
 */
public abstract class ReachabilityProofRule 
{
  
  protected AlgebraValue top;
  protected AlgebraValue bot;
  protected AlgebraValue iTop;
  protected AlgebraValue iBot;
  
  BelnapAlgebra algebra;
  

  /**
   * Creates a new <code>ReachabilityProofRule</code> instance.
   *
   */
  public ReachabilityProofRule (BelnapAlgebra _algebra) 
  {
    setAlgebra (_algebra);
  }

  
  private void setAlgebra (BelnapAlgebra v)
  {
    algebra = v;
    top = v.top ();
    bot = v.bot ();
    iTop = v.infoTop ();
    iBot = v.infoBot ();
  }

  public abstract ProofGoal[] apply (ProofGoal g);
  
  protected ProofGoal[] oneGoal (ProofGoal g)
  {
    return new ProofGoal [] { g };
  }
  
  protected ProofGoal[] twoGoal (ProofGoal g1, ProofGoal g2)
  {
    return new ProofGoal[] { g1, g2 };
  }

  protected ProofGoal[] threeGoal (ProofGoal g1, ProofGoal g2, 
				   ProofGoal g3)
  {
    return new ProofGoal[] { g1, g2, g3 };
  }
  
    
  
}
