package edu.toronto.cs.yasm.wp;

import edu.toronto.cs.expr.*;
import java.util.*;

/**
 * A weakest pre-condition for a statements about which we only know
 * that it changes a variable. The behaviour of this WP is
 *{@code
 wp(e) == false if e contains v and e otherwise
 }, where {@code v} is the variable being changed.
 *
 * @author <a href="mailto:arie@kanga.fm.sandbox">Arie Gurfinkel</a>
 * @version 1.0
 */
public class UnknownExprWPComputer 
  extends BaseWPComputer 
  implements WPComputer
{

  // -- variable being changed
  Expr var;

  public UnknownExprWPComputer (Expr _var)
  {
    var = _var;
  }

  public Expr computeWP (Expr expr)
  {
    if (expr.contains (var))
      return ChoiceOp.lchoice (expr.getFactory ().falseExpr (), 
			       expr.getFactory ().falseExpr ());
    
    
    return expr;  
  }
}

