/* Cat a string of length 50 onto another 
 * string of length 50, the latter of which 
 * is contained by a 101-element array.
 *
 * YASM can verify that ERR2 is unreachable 
 * using the predicates in strcat2.pred:
 *
 * $ yasm --refiner "cbj-i-s" \
 *   --init-pred "strcat2.pred" strcat2.c --blocking \
 *   -p "EF pc=ERR2"
 */
int main()
{
  char src [100];
  char dest [101];
  int i;
  int j;

  int _j;

  i = 0;
  j = 0;

  src[50] = 0;

  dest[50] = 0;

  /* Find the end of dest, this is where 
   * we start overwriting from.
   *
   */
  /* Invariant: j <= 50 && dest[50] == 0 */
  while (dest[j] != 0)
	  j++;
  if (! (j <= 50))
	ERR0:;

  /* Invariant: (i <= 50 && src[50] == 0) */
  /* and _j <= _i */
  _j = 0;
  if (! (_j <= i))
	  ERR1:;
  if (! (_j <= 50))
	  ERR1a:;
  while (src[i] != 0) {
	  if (! (j + _j < 101))
		  ERR2:;
	  if (! (j + _j < 99))
		  REACHABLE2:;

	  i = i + 1;
	  _j = _j + 1;

	  if (! (_j <= i))
		  ERR3:;
	  if (! (i <= 50))
		  ERR3a:;
	  if (! (j <= 50))
		  ERR3b:;
	  if (! (j+ _j <= j + i))
		  ERR3c:;
	  /* Note: to verify this, we need full cbj. 
	   * cbj-i and cbj-i-s diverge. 
	   *
	   * With cbj, we can verify this in one 
	   * iteration, but we need ~4 mins. 
	   *
	   * Using full cbj currently leads to CVCL 
	   * hanging....
	   */
	  if (! (_j <= 50))
		  ERR3d:; 
  }

  if (! (i <= 50))
	  ERR4:;
  if (! (_j <= i))
	  ERR4a:;
  if (! (_j <= 50))
	  ERR4b:;

  j = j + _j;
  /* Can verify this, but we need full cbj.
   *
   * It takes 10 mins, 18 s.
   *
   * And I thought it was just hung!!
   */
  if (! (j < 101))
	  ERR5:;

  return 0;
}
