#!/bin/bash

echo "A small test script"

# check that everything is in order
if [ ! -x bin/yasm ] ; then
  echo "Missing or non-executable bin/yasm script"
  exit 1
fi

if [ ! -x bin/yasr ] ; then
  echo "MIssing or non-executable bin/yasr script"
  exit 1
fi

TEST1=play/models/cprog/test2.cil.c
TEST2=play/models/cprog/test3.cil.c

if [ ! -f $TEST1 ] ; then
    echo "Missing test file: $TEST1"
    exit 1
fi

if [ ! -f $TEST2 ] ; then
    echo "Missing test file: $TEST2"
    exit 1
fi

echo "**********************************************************************"
echo "YASM TESTS"
echo "**********************************************************************"

echo "Test 1"
bin/yasm --parser antlr -p 'EF pc = END' $TEST1

echo "Test 2"
bin/yasm --parser antlr --blocking -p 'EF pc = END' $TEST1

echo "Test 3"
bin/yasm --parser antlr --blocking -p 'EG !(pc = END)' $TEST1

echo "Test 3"
bin/yasm --parser antlr --blocking -p 'EF (pc = END)' $TEST2

echo "Test 4"
bin/yasm --parser antlr --blocking -p 'EG !(pc = END)' $TEST2

echo "**********************************************************************"
echo "YASR TESTS"
echo "**********************************************************************"

echo "Test 1"
bin/yasr -p 'EF pc = END' $TEST1

echo "Test 2"
bin/yasr --blocking -p 'EF pc = END' $TEST1

echo "Test 3"
bin/yasr --blocking -p 'EG true' $TEST1

echo "Test 3"
bin/yasr --blocking -p 'EF (pc = END)' $TEST2

echo "Test 4"
bin/yasr --blocking -p 'EG true' $TEST2
